<?php
/*
******************************************************************************************
*                                                                                        *
*    Photo Contest Web Application v1.6                                                  *
*    Copyright (C) Nov 7, 2011  Subhrajit Bhattacharya                                   *
*                                                                                        *
*    This program is free software: you can redistribute it and/or modify                *
*    it under the terms of the GNU General Public License as published by                *
*    the Free Software Foundation, either version 3 of the License, or                   *
*    (at your option) any later version.                                                 *
*                                                                                        *
*    This program is distributed in the hope that it will be useful,                     *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of                      *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                       *
*    GNU General Public License for more details <http://www.gnu.org/licenses/>.         *
*                                                                                        *
*                                                                                        *
*    Contact: subhrajit@gmail.com, http://www.subhrajit.net/                             *
*                                                                                        *
*                                                                                        *
******************************************************************************************
*/

// ============================================================================
// GENERAL INFO AND SETTINGS
// TODO: Change these.

$info_photocontest->allowupload = true; // true or false. TODO: Set to 'false' to shut down upload form.
$info_photocontest->askifstudent = true; // Ask whether a student. true or false.
$info_photocontest->photocontest = true; // Is there a photo-contest. true or false.
$info_photocontest->hidename = true; // Hide names of photographers for privacy or fair review

// Set the conference details:
$info_photocontest->confname = "Conference Name, YYYY";
$info_photocontest->confdate = "Month DD-DD, YYYY";
$info_photocontest->bannerURL = "http://www.conference-name.com/banner.png"; // Set to empty to disable banner.
$info_photocontest->deadline = "Month DD, YYYY"; // Deadline for photo contest, if enabled

// Layouts:
//         "embeded"  - if using inside frame or iframe in another websiite.
//         "windowed" - if displaying in a whole window.
// Set 'stylesheet' to custom style sheet
$info_photocontest->layout = "windowed"; // this option is vestigial
$info_photocontest->stylesheet = "style.css"; // No need to change this.
$info_photocontest->containerwidth = "600"; // Adjust width of the form/album if you need to.
$info_photocontest->topLinks = array(
            "View Photos" => "view.php?details=public",
            "Conference main site" => "http://www.conference-name.com/"
            );

// Upload limits:
$info_photocontest->maxuploadsize = 2; // in MB
$info_photocontest->uploadfilenos = 2;


// ============================================================================
// VIEW SETTINGS

$display_photocontest->ImagesPerLine = 3;
$display_photocontest->LinesPerPage = 5;
$display_photocontest->ThumbMaxWidth = 120;
$display_photocontest->ThumbMaxHeight = 80;

// TODO: Change this. WARNING: Do not use URL special characters for 'adminpass'. These are the characters '/', '&', '=', '%', ':' and space.
$display_photocontest->adminpass = "admin_password";

// ============================================================================
// DATABASE SETTINGS

// TODO: Change these:
$db_info_photocontest->host = "mysql.database-host-name.com";
$db_info_photocontest->user = "mysql_user_name";
$db_info_photocontest->pass = "mysql_user_password";
$db_info_photocontest->dbname = "database_name";
$db_info_photocontest->table = "photomanager"; // Change this if you are hosting multiple photo albums in same DB

// ============================================================================
// FILE FOLDER - No need to change these!

$upload_photocontest->relfolder = "upload/"; // Not very necessary to change this
$upload_photocontest->folderURL = "http://".dirname($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'])."/".$upload_photocontest->relfolder; // No need to change this

// ****************************************************************************
// ****************************************************************************



session_start();
$info_photocontest->maxuploadsize_bytes = $info_photocontest->maxuploadsize * 1024 * 1024;

/* Short library containing functions to access databasse */

$db_info_photocontest->connected = FALSE;

function db_connect_photocontest() {
    global $db_info_photocontest;
    $db_info_photocontest->res = mysql_connect($db_info_photocontest->host, $db_info_photocontest->user, $db_info_photocontest->pass);
    if (!$db_info_photocontest->res)
        die("ERROR: Failed to connect to DB!".mysql_error());
    else
    {
        if (!mysql_select_db($db_info_photocontest->dbname))
            die("ERROR: Failed to select DB!".mysql_error());
        else
            $db_info_photocontest->connected = TRUE;
    }
}

function db_close_photocontest() {
    global $db_info_photocontest;
    if (mysql_close($db_info_photocontest->res))
        $db_info_photocontest->connected = FALSE;
    else
        die("ERROR: Failed to disconnect from DB!".mysql_error());
}

function db_test_photocontest() {
    global $db_info_photocontest, $upload_photocontest;
    $table_list = mysql_query("SHOW TABLES LIKE '".$db_info_photocontest->table."'");
    if (!$table_list || mysql_num_rows($table_list)==0)
    {
        mysql_query("CREATE TABLE ".$db_info_photocontest->table."(
                        id INT NOT NULL AUTO_INCREMENT, PRIMARY KEY(id),
                        name VARCHAR(255),
                        affiliation VARCHAR(255),
                        email VARCHAR(255),
                        student ENUM('yes','no'),
                        contest ENUM('yes','no'),
                        filename VARCHAR(255),
                        public ENUM('yes','no') DEFAULT 'yes',
                        caption TEXT
                    )") or die(mysql_error());
        print("Created table ".$db_info_photocontest->table);
     }
     if (!is_dir($upload_photocontest->relfolder))
        mkdir($upload_photocontest->relfolder);
     chmod($upload_photocontest->relfolder, 0755);
}

function get_next_file_name_photocontest($suffix) {
    global $db_info_photocontest;
    $rec_count = mysql_query("SELECT MAX(id) FROM ".$db_info_photocontest->table);
    if ($row = mysql_fetch_array($rec_count, MYSQL_NUM))
        return "IMG_".$row[0]."_".$suffix;
}

function db_insert_photocontest($name, $affiliation, $email, $student, $contest, $filename, $caption) {
    global $db_info_photocontest;
    $queryString = "INSERT INTO ".$db_info_photocontest->table." SET ".
                    " name = '".rawurlencode($name)."', ".
                    " affiliation = '".rawurlencode($affiliation)."', ".
                    " email = '".rawurlencode($email)."', ".
                    " student = '".rawurlencode($student)."', ".
                    " contest = '".rawurlencode($contest)."', ".
                    " filename = '".$filename."', ".
                    " caption = '".rawurlencode($caption)."'";
    return (mysql_query($queryString));
}

/* Use:
 db_connect_photocontest();
 db_test_photocontest();
     Do other stuffs here
 db_close_photocontest();
*/

// ============================================================================

function createThumb ($fname, $thumbwidth, $thumbheight)
{
    global $upload_photocontest;
	$sysCommand = "convert ".$upload_photocontest->folderURL.$fname.".JPG"." -resize ".$thumbwidth."x".$thumbheight.
	              " ".$upload_photocontest->relfolder.$fname."_thumb.JPG".
	              " 2>&1";
	$shellOut = shell_exec($sysCommand);
	chmod($upload_photocontest->relfolder.$fname."_thumb.JPG", 0755);
	return (file_exists($upload_photocontest->relfolder.$fname."_thumb.JPG"));
}

function getThumb_sub ($fname, $thumbwidth, $thumbheight)
{
    // $fname must contain path relative to $upload_photocontest->relfolder
    global $upload_photocontest;
    $pathparts = pathinfo($fname);
    
    if (!is_dir($upload_photocontest->relfolder.$pathparts['dirname']."/thumbs"))
        mkdir($upload_photocontest->relfolder.$pathparts['dirname']."/thumbs");
    chmod($upload_photocontest->relfolder.$pathparts['dirname']."/thumbs", 0755);
    
    $sanitized_name = preg_replace('/[^0-9a-z\.\_\-]/i','',$pathparts['filename']);
    if ($sanitized_name != $pathparts['filename'])
    {
        if (rename($upload_photocontest->relfolder.$fname,
                   $upload_photocontest->relfolder.$pathparts['dirname']."/".$sanitized_name.".".$pathparts['extension']))

        {
            $fname = $pathparts['dirname']."/".$sanitized_name.".".$pathparts['extension'];
            $pathparts = pathinfo($fname);
        }
    }
    
    $thumbfname = $pathparts['dirname']."/thumbs/".md5($pathparts['basename']).".JPG";
    if (!file_exists($upload_photocontest->relfolder.$thumbfname))
    {
	    $sysCommand = "convert ".$upload_photocontest->relfolder.$fname." -resize ".$thumbwidth."x".$thumbheight.
	                  " ".$upload_photocontest->relfolder.$thumbfname." 2>&1";
	    $shellOut = shell_exec($sysCommand);
	    //print($sysCommand."<br/>".$shellOut);
	    chmod($upload_photocontest->relfolder.$thumbfname, 0755);
	}
	
	if (file_exists($upload_photocontest->relfolder.$thumbfname))
	    return $thumbfname;
	else
	    return (FALSE);
}

?>

